<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="100px">
      <el-form-item label="证书编号" prop="certCode">
        <el-input v-model="queryParams.certCode" placeholder="请输入证书编号" clearable @keyup.enter="handleQuery" />
      </el-form-item>
      <el-form-item label="核实是否同意" prop="veriIfAgree">
        <el-select v-model="queryParams.veriIfAgree" placeholder="请选择核实是否同意" clearable>
          <el-option v-for="dict in sys_yes_no" :key="dict.value" :label="dict.label" :value="dict.value" />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="Plus" @click="handleAdd" v-hasPermi="['ttsa:ttsacertreisappl:add']">新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Edit" :disabled="single" @click="handleUpdate" v-hasPermi="['ttsa:ttsacertreisappl:edit']">修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete" v-hasPermi="['ttsa:ttsacertreisappl:remove']">删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="warning" plain icon="Download" @click="handleExport" v-hasPermi="['ttsa:ttsacertreisappl:export']">导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList" :columns="columns" storageKey="ttsa-ttsacertreisappl-index"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="dataList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="申请单位编号" prop="applWiunCode" />
      <el-table-column label="证书编号" prop="certCode" />
      <el-table-column label="发证时间" prop="issueTime" width="180" />
      <el-table-column label="申请时间" prop="apllTime" width="180" />
      <el-table-column label="核实人" prop="veriPers" />
      <el-table-column label="核实是否同意" prop="veriIfAgree" width="120">
        <template #default="scope">
          <dict-tag :options="sys_yes_no" :value="scope.row.veriIfAgree" />
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="200">
        <template #default="scope">
          <el-tooltip content="修改" placement="top">
            <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['ttsa:ttsacertreisappl:edit']"></el-button>
          </el-tooltip>
          <el-tooltip content="删除" placement="top">
            <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['ttsa:ttsacertreisappl:remove']"></el-button>
          </el-tooltip>
        </template>
      </el-table-column>
    </el-table>

    <pagination v-show="total>0" :total="total" v-model:page="queryParams.pageNum" v-model:limit="queryParams.pageSize" @pagination="getList" />

    <el-dialog :title="title" v-model="open" width="600px" append-to-body>
      <el-form ref="formRef" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="申请单位编号" prop="applWiunCode">
          <el-input v-model="form.applWiunCode" placeholder="请输入申请单位编号" />
        </el-form-item>
        <el-form-item label="证书编号" prop="certCode">
          <el-input v-model="form.certCode" placeholder="请输入证书编号" />
        </el-form-item>
        <el-form-item label="发证时间" prop="issueTime">
          <el-date-picker v-model="form.issueTime" type="datetime" placeholder="选择发证时间" clearable />
        </el-form-item>
        <el-form-item label="申请时间" prop="apllTime">
          <el-date-picker v-model="form.apllTime" type="datetime" placeholder="选择申请时间" clearable />
        </el-form-item>
        <el-form-item label="核实时间" prop="veriTime">
          <el-date-picker v-model="form.veriTime" type="datetime" placeholder="选择核实时间" clearable />
        </el-form-item>
        <el-form-item label="核实人" prop="veriPers">
          <el-input v-model="form.veriPers" placeholder="请输入核实人" />
        </el-form-item>
        <el-form-item label="核实是否同意" prop="veriIfAgree">
          <el-input v-model="form.veriIfAgree" placeholder="请输入核实是否同意" />
        </el-form-item>
        <el-form-item label="核实意见" prop="wiunOpin">
          <el-input v-model="form.wiunOpin" type="textarea" placeholder="请输入核实意见" />
        </el-form-item>
        <el-form-item label="备注" prop="note">
          <el-input v-model="form.note" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="TtsaCertReisAppl">
import { listBisTtsaCertReisAppl, getBisTtsaCertReisAppl, addBisTtsaCertReisAppl, updateBisTtsaCertReisAppl, delBisTtsaCertReisAppl } from "@/api/slaj/ttsa";
import { getCurrentInstance, reactive, ref, toRefs } from "vue";

const { proxy } = getCurrentInstance();
const { sys_yes_no } = proxy.useDict("sys_yes_no");

const dataList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const columns = ref({ applWiunCode: { visible: true }, certCode: { visible: true }, issueTime: { visible: true }, apllTime: { visible: true }, veriPers: { visible: true }, veriIfAgree: { visible: true } });

const data = reactive({
  form: {},
  queryParams: { pageNum: 1, pageSize: 10, certCode: null, veriIfAgree: null },
  rules: {}
});
const { form, queryParams, rules } = toRefs(data);

function getList() {
  loading.value = true;
  listBisTtsaCertReisAppl(queryParams.value).then(r => {
    dataList.value = r.rows;
    total.value = r.total;
    loading.value = false;
  });
}

function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

function handleSelectionChange(s) {
  ids.value = s.map(i => i.guid);
  single.value = s.length !== 1;
  multiple.value = !s.length;
}

function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加补发申请";
}

function handleUpdate(row) {
  reset();
  getBisTtsaCertReisAppl(row.guid || ids.value[0]).then(r => {
    form.value = r.data;
    open.value = true;
    title.value = "修改补发申请";
  });
}

function submitForm() {
  proxy.$refs["formRef"].validate(v => {
    if (v) {
      if (form.value.guid != null) {
        updateBisTtsaCertReisAppl(form.value).then(() => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addBisTtsaCertReisAppl(form.value).then(() => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

function handleDelete(row) {
  proxy.$modal.confirm('确认删除？').then(() => delBisTtsaCertReisAppl(row.guid || ids.value.join(","))).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  });
}

function handleExport() {
  proxy.download('/ttsa/ttsacertreisappl/export', { ...queryParams.value }, `补发申请_${new Date().getTime()}.xlsx`);
}

function cancel() {
  open.value = false;
  reset();
}

function reset() {
  form.value = { guid: null, applWiunCode: null, certCode: null, issueTime: null, apllTime: null, veriTime: null, veriPers: null, veriIfAgree: null, wiunOpin: null, note: null };
  proxy.resetForm("formRef");
}

getList();
</script>
